function GetOciTopLevelCommand_opsi() {
    return 'opsi'
}

function GetOciSubcommands_opsi() {
    $ociSubcommands = @{
        'opsi' = 'awr-hubs database-insights enterprise-manager-bridges exadata-insights host-insights operations-insights-warehouse-users operations-insights-warehouses work-requests'
        'opsi awr-hubs' = 'create delete get get-awr-report list list-awr-snapshots summarize-awr-sources-summaries update'
        'opsi database-insights' = 'change create-em-external-db delete disable enable-em-external-db get ingest-database-configuration ingest-sql-bucket ingest-sql-plan-lines ingest-sql-stats ingest-sql-text list list-database-configurations list-sql-plans list-sql-searches list-sql-texts summarize-database-insight-resource-capacity-trend summarize-database-insight-resource-forecast-trend summarize-database-insight-resource-statistics summarize-database-insight-resource-usage summarize-database-insight-resource-usage-trend summarize-database-insight-resource-utilization-insight summarize-database-insight-tablespace-usage-trend summarize-sql-insights summarize-sql-plan-insights summarize-sql-response-time-distributions summarize-sql-statistics summarize-sql-statistics-time-series summarize-sql-statistics-time-series-by-plan update-autonomous-db update-em-external-db update-macs-external-db'
        'opsi enterprise-manager-bridges' = 'change create delete get list list-importable-enterprise-manager-entities update'
        'opsi exadata-insights' = 'add-em-external-exadata-members change create-em-external-exadata delete disable enable-em-external-exadata get list list-exadata-configurations summarize-exadata-insight-resource-capacity-trend summarize-exadata-insight-resource-capacity-trend-aggregated summarize-exadata-insight-resource-forecast-trend summarize-exadata-insight-resource-forecast-trend-aggregated summarize-exadata-insight-resource-statistics summarize-exadata-insight-resource-usage summarize-exadata-insight-resource-usage-aggregated summarize-exadata-insight-resource-utilization-insight summarize-exadata-members update-em-external-exadata'
        'opsi host-insights' = 'change create-em-external-host create-macs-external-host delete disable enable-em-external-host enable-macs-external-host get ingest-host-configuration ingest-host-metrics list list-host-configurations list-hosted-entities list-importable-agent-entities summarize-host-insight-resource-capacity-trend summarize-host-insight-resource-forecast-trend summarize-host-insight-resource-statistics summarize-host-insight-resource-usage summarize-host-insight-resource-usage-trend summarize-host-insight-resource-utilization-insight update-em-external-host update-macs-external-host'
        'opsi operations-insights-warehouse-users' = 'create delete get list update'
        'opsi operations-insights-warehouses' = 'create delete download-warehouse-wallet get list rotate-warehouse-wallet summarize-operations-insights-warehouse-resource-usage update'
        'opsi work-requests' = 'get list'
    }
    return $ociSubcommands
}

function GetOciCommandsToLongParams_opsi() {
    $ociCommandsToLongParams = @{
        'opsi awr-hubs create' = 'compartment-id defined-tags display-name freeform-tags from-json help max-wait-seconds object-storage-bucket-name operations-insights-warehouse-id wait-for-state wait-interval-seconds'
        'opsi awr-hubs delete' = 'awr-hub-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi awr-hubs get' = 'awr-hub-id from-json help'
        'opsi awr-hubs get-awr-report' = 'awr-hub-id awr-source-database-identifier begin-snapshot-identifier-greater-than-or-equal-to end-snapshot-identifier-less-than-or-equal-to from-json help instance-number report-format time-greater-than-or-equal-to time-less-than-or-equal-to'
        'opsi awr-hubs list' = 'all compartment-id display-name from-json help id lifecycle-state limit operations-insights-warehouse-id page page-size sort-by sort-order'
        'opsi awr-hubs list-awr-snapshots' = 'all awr-hub-id awr-source-database-identifier from-json help limit page page-size sort-by sort-order time-greater-than-or-equal-to time-less-than-or-equal-to'
        'opsi awr-hubs summarize-awr-sources-summaries' = 'awr-hub-id compartment-id from-json help limit name page sort-by sort-order'
        'opsi awr-hubs update' = 'awr-hub-id defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights change' = 'compartment-id database-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights create-em-external-db' = 'compartment-id defined-tags em-bridge-id em-entity-id em-id exadata-insight-id freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights delete' = 'database-insight-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights disable' = 'database-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights enable-em-external-db' = 'database-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights get' = 'database-insight-id from-json help'
        'opsi database-insights ingest-database-configuration' = 'database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-bucket' = 'compartment-id database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-plan-lines' = 'compartment-id database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-stats' = 'database-id from-json help id if-match items'
        'opsi database-insights ingest-sql-text' = 'compartment-id database-id from-json help id if-match items'
        'opsi database-insights list' = 'all compartment-id compartment-id-in-subtree database-id database-type em-bridge-id exadata-insight-id fields from-json help id lifecycle-state limit page page-size sort-by sort-order status'
        'opsi database-insights list-database-configurations' = 'all cdb-name compartment-id compartment-id-in-subtree database-id database-type defined-tag-equals defined-tag-exists em-bridge-id exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id limit page page-size sort-by sort-order'
        'opsi database-insights list-sql-plans' = 'all compartment-id database-id from-json help id page plan-hash sql-identifier'
        'opsi database-insights list-sql-searches' = 'all analysis-time-interval compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights list-sql-texts' = 'all compartment-id compartment-id-in-subtree database-id defined-tag-equals defined-tag-exists freeform-tag-equals freeform-tag-exists from-json help id page sql-identifier'
        'opsi database-insights summarize-database-insight-resource-capacity-trend' = 'analysis-time-interval cdb-name compartment-id compartment-id-in-subtree database-id database-type defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric sort-by sort-order tablespace-name time-interval-end time-interval-start utilization-level'
        'opsi database-insights summarize-database-insight-resource-forecast-trend' = 'analysis-time-interval cdb-name compartment-id compartment-id-in-subtree confidence database-id database-type defined-tag-equals defined-tag-exists exadata-insight-id forecast-days forecast-model freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric statistic tablespace-name time-interval-end time-interval-start utilization-level'
        'opsi database-insights summarize-database-insight-resource-statistics' = 'analysis-time-interval cdb-name compartment-id compartment-id-in-subtree database-id database-type defined-tag-equals defined-tag-exists exadata-insight-id forecast-days freeform-tag-equals freeform-tag-exists from-json help host-name id insight-by is-database-instance-level-metrics limit page percentile resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-resource-usage' = 'analysis-time-interval compartment-id compartment-id-in-subtree database-id database-type defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page percentile resource-metric time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-resource-usage-trend' = 'analysis-time-interval compartment-id compartment-id-in-subtree database-id database-type defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-resource-utilization-insight' = 'analysis-time-interval compartment-id compartment-id-in-subtree database-id database-type defined-tag-equals defined-tag-exists exadata-insight-id forecast-days freeform-tag-equals freeform-tag-exists from-json help host-name id is-database-instance-level-metrics page resource-metric time-interval-end time-interval-start'
        'opsi database-insights summarize-database-insight-tablespace-usage-trend' = 'analysis-time-interval compartment-id database-id from-json help id limit page time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-insights' = 'analysis-time-interval cdb-name compartment-id compartment-id-in-subtree database-id database-time-pct-greater-than database-type defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id page time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-plan-insights' = 'analysis-time-interval compartment-id database-id from-json help id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-response-time-distributions' = 'analysis-time-interval compartment-id database-id from-json help id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-statistics' = 'analysis-time-interval category cdb-name compartment-id compartment-id-in-subtree database-id database-time-pct-greater-than database-type defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id limit page sort-by sort-order sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-statistics-time-series' = 'analysis-time-interval cdb-name compartment-id compartment-id-in-subtree database-id defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help host-name id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights summarize-sql-statistics-time-series-by-plan' = 'analysis-time-interval compartment-id database-id from-json help id page sql-identifier time-interval-end time-interval-start'
        'opsi database-insights update-autonomous-db' = 'database-insight-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights update-em-external-db' = 'database-insight-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi database-insights update-macs-external-db' = 'database-insight-id defined-tags force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges change' = 'compartment-id enterprise-manager-bridge-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges create' = 'compartment-id defined-tags description display-name freeform-tags from-json help max-wait-seconds object-storage-bucket-name wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges delete' = 'enterprise-manager-bridge-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi enterprise-manager-bridges get' = 'enterprise-manager-bridge-id from-json help'
        'opsi enterprise-manager-bridges list' = 'all compartment-id compartment-id-in-subtree display-name from-json help id lifecycle-state limit page page-size sort-by sort-order'
        'opsi enterprise-manager-bridges list-importable-enterprise-manager-entities' = 'all em-entity-type em-id em-parent-id enterprise-manager-bridge-id from-json help limit page page-size'
        'opsi enterprise-manager-bridges update' = 'defined-tags description display-name enterprise-manager-bridge-id force freeform-tags from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi exadata-insights add-em-external-exadata-members' = 'exadata-insight-id from-json help if-match max-wait-seconds member-entity-details wait-for-state wait-interval-seconds'
        'opsi exadata-insights change' = 'compartment-id exadata-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi exadata-insights create-em-external-exadata' = 'compartment-id defined-tags em-bridge-id em-entity-id em-id freeform-tags from-json help is-auto-sync-enabled max-wait-seconds member-entity-details wait-for-state wait-interval-seconds'
        'opsi exadata-insights delete' = 'exadata-insight-id force from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi exadata-insights disable' = 'exadata-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi exadata-insights enable-em-external-exadata' = 'exadata-insight-id from-json help if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi exadata-insights get' = 'exadata-insight-id from-json help'
        'opsi exadata-insights list' = 'all compartment-id compartment-id-in-subtree em-bridge-id exadata-type from-json help id lifecycle-state limit page page-size sort-by sort-order status'
        'opsi exadata-insights list-exadata-configurations' = 'all compartment-id defined-tag-equals defined-tag-exists exadata-insight-id exadata-type freeform-tag-equals freeform-tag-exists from-json help limit page page-size sort-by sort-order'
        'opsi exadata-insights summarize-exadata-insight-resource-capacity-trend' = 'analysis-time-interval cdb-name compartment-id database-insight-id exadata-insight-id exadata-type from-json help host-insight-id host-name limit page resource-metric resource-type sort-by sort-order storage-server-name time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-capacity-trend-aggregated' = 'analysis-time-interval cdb-name compartment-id defined-tag-equals defined-tag-exists exadata-insight-id exadata-type freeform-tag-equals freeform-tag-exists from-json help host-name page resource-metric resource-type sort-by sort-order time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-forecast-trend' = 'analysis-time-interval cdb-name confidence database-insight-id exadata-insight-id exadata-type forecast-days forecast-model forecast-start-day from-json help host-insight-id host-name limit page resource-metric resource-type sort-by sort-order statistic storage-server-name time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-forecast-trend-aggregated' = 'analysis-time-interval cdb-name compartment-id confidence defined-tag-equals defined-tag-exists exadata-insight-id exadata-type forecast-days forecast-model forecast-start-day freeform-tag-equals freeform-tag-exists from-json help host-name page resource-metric resource-type statistic time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-statistics' = 'analysis-time-interval cdb-name exadata-insight-id exadata-type from-json help host-name limit page percentile resource-metric resource-type sort-by sort-order time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-usage' = 'analysis-time-interval cdb-name compartment-id defined-tag-equals defined-tag-exists exadata-insight-id exadata-type freeform-tag-equals freeform-tag-exists from-json help host-name limit page percentile resource-metric resource-type sort-by sort-order time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-usage-aggregated' = 'analysis-time-interval cdb-name compartment-id defined-tag-equals defined-tag-exists exadata-insight-id exadata-type freeform-tag-equals freeform-tag-exists from-json help host-name page percentile resource-metric resource-type time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-insight-resource-utilization-insight' = 'analysis-time-interval cdb-name compartment-id defined-tag-equals defined-tag-exists exadata-insight-id exadata-type forecast-days forecast-start-day freeform-tag-equals freeform-tag-exists from-json help host-name limit page resource-metric resource-type time-interval-end time-interval-start'
        'opsi exadata-insights summarize-exadata-members' = 'exadata-insight-id exadata-type from-json help limit page sort-by sort-order'
        'opsi exadata-insights update-em-external-exadata' = 'defined-tags exadata-insight-id force freeform-tags from-json help if-match is-auto-sync-enabled max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights change' = 'compartment-id from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights create-em-external-host' = 'compartment-id defined-tags em-bridge-id em-entity-id em-id exadata-insight-id freeform-tags from-json help max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights create-macs-external-host' = 'compartment-id defined-tags freeform-tags from-json help management-agent-id max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights delete' = 'force from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights disable' = 'from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights enable-em-external-host' = 'from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights enable-macs-external-host' = 'from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights get' = 'from-json help host-insight-id'
        'opsi host-insights ingest-host-configuration' = 'from-json help id if-match items'
        'opsi host-insights ingest-host-metrics' = 'from-json help id if-match items'
        'opsi host-insights list' = 'all compartment-id compartment-id-in-subtree em-bridge-id exadata-insight-id from-json help host-type id lifecycle-state limit page page-size platform-type sort-by sort-order status'
        'opsi host-insights list-host-configurations' = 'all compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists em-bridge-id exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help id limit page page-size platform-type sort-by sort-order'
        'opsi host-insights list-hosted-entities' = 'all analysis-time-interval compartment-id exadata-insight-id from-json help id limit page page-size platform-type sort-by sort-order time-interval-end time-interval-start'
        'opsi host-insights list-importable-agent-entities' = 'all compartment-id from-json help limit page page-size sort-by sort-order'
        'opsi host-insights summarize-host-insight-resource-capacity-trend' = 'analysis-time-interval compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric sort-by sort-order time-interval-end time-interval-start utilization-level'
        'opsi host-insights summarize-host-insight-resource-forecast-trend' = 'analysis-time-interval compartment-id compartment-id-in-subtree confidence defined-tag-equals defined-tag-exists exadata-insight-id forecast-days forecast-model freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric statistic time-interval-end time-interval-start utilization-level'
        'opsi host-insights summarize-host-insight-resource-statistics' = 'analysis-time-interval compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists exadata-insight-id forecast-days freeform-tag-equals freeform-tag-exists from-json help id insight-by limit page percentile platform-type resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-usage' = 'analysis-time-interval compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help id page percentile platform-type resource-metric time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-usage-trend' = 'analysis-time-interval compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists exadata-insight-id freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric sort-by sort-order time-interval-end time-interval-start'
        'opsi host-insights summarize-host-insight-resource-utilization-insight' = 'analysis-time-interval compartment-id compartment-id-in-subtree defined-tag-equals defined-tag-exists exadata-insight-id forecast-days freeform-tag-equals freeform-tag-exists from-json help id page platform-type resource-metric time-interval-end time-interval-start'
        'opsi host-insights update-em-external-host' = 'defined-tags force freeform-tags from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi host-insights update-macs-external-host' = 'defined-tags force freeform-tags from-json help host-insight-id if-match max-wait-seconds wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouse-users create' = 'compartment-id connection-password defined-tags freeform-tags from-json help is-awr-data-access is-em-data-access is-opsi-data-access max-wait-seconds name operations-insights-warehouse-id wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouse-users delete' = 'force from-json help if-match max-wait-seconds operations-insights-warehouse-user-id wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouse-users get' = 'from-json help operations-insights-warehouse-user-id'
        'opsi operations-insights-warehouse-users list' = 'all compartment-id display-name from-json help id lifecycle-state limit operations-insights-warehouse-id page page-size sort-by sort-order'
        'opsi operations-insights-warehouse-users update' = 'connection-password defined-tags force freeform-tags from-json help if-match is-awr-data-access is-em-data-access is-opsi-data-access max-wait-seconds operations-insights-warehouse-user-id wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouses create' = 'compartment-id cpu-allocated defined-tags display-name freeform-tags from-json help max-wait-seconds storage-allocated-in-gbs wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouses delete' = 'force from-json help if-match max-wait-seconds operations-insights-warehouse-id wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouses download-warehouse-wallet' = 'file from-json help operations-insights-warehouse-id operations-insights-warehouse-wallet-password'
        'opsi operations-insights-warehouses get' = 'from-json help operations-insights-warehouse-id'
        'opsi operations-insights-warehouses list' = 'all compartment-id display-name from-json help id lifecycle-state limit page page-size sort-by sort-order'
        'opsi operations-insights-warehouses rotate-warehouse-wallet' = 'from-json help if-match max-wait-seconds operations-insights-warehouse-id wait-for-state wait-interval-seconds'
        'opsi operations-insights-warehouses summarize-operations-insights-warehouse-resource-usage' = 'from-json help operations-insights-warehouse-id'
        'opsi operations-insights-warehouses update' = 'cpu-allocated defined-tags display-name force freeform-tags from-json help if-match max-wait-seconds operations-insights-warehouse-id storage-allocated-in-gbs wait-for-state wait-interval-seconds'
        'opsi work-requests get' = 'from-json help work-request-id'
        'opsi work-requests list' = 'all compartment-id from-json help id limit page page-size related-resource-id resource-id sort-by sort-order status'
    }
    return $ociCommandsToLongParams
}

function GetOciCommandsToShortParams_opsi() {
    $ociCommandsToShortParams = @{
        'opsi awr-hubs create' = '? c h'
        'opsi awr-hubs delete' = '? h'
        'opsi awr-hubs get' = '? h'
        'opsi awr-hubs get-awr-report' = '? h'
        'opsi awr-hubs list' = '? c h'
        'opsi awr-hubs list-awr-snapshots' = '? h'
        'opsi awr-hubs summarize-awr-sources-summaries' = '? c h'
        'opsi awr-hubs update' = '? h'
        'opsi database-insights change' = '? c h'
        'opsi database-insights create-em-external-db' = '? c h'
        'opsi database-insights delete' = '? h'
        'opsi database-insights disable' = '? h'
        'opsi database-insights enable-em-external-db' = '? h'
        'opsi database-insights get' = '? h'
        'opsi database-insights ingest-database-configuration' = '? h'
        'opsi database-insights ingest-sql-bucket' = '? c h'
        'opsi database-insights ingest-sql-plan-lines' = '? c h'
        'opsi database-insights ingest-sql-stats' = '? h'
        'opsi database-insights ingest-sql-text' = '? c h'
        'opsi database-insights list' = '? c h'
        'opsi database-insights list-database-configurations' = '? c h'
        'opsi database-insights list-sql-plans' = '? c h'
        'opsi database-insights list-sql-searches' = '? c h'
        'opsi database-insights list-sql-texts' = '? c h'
        'opsi database-insights summarize-database-insight-resource-capacity-trend' = '? c h'
        'opsi database-insights summarize-database-insight-resource-forecast-trend' = '? c h'
        'opsi database-insights summarize-database-insight-resource-statistics' = '? c h'
        'opsi database-insights summarize-database-insight-resource-usage' = '? c h'
        'opsi database-insights summarize-database-insight-resource-usage-trend' = '? c h'
        'opsi database-insights summarize-database-insight-resource-utilization-insight' = '? c h'
        'opsi database-insights summarize-database-insight-tablespace-usage-trend' = '? c h'
        'opsi database-insights summarize-sql-insights' = '? c h'
        'opsi database-insights summarize-sql-plan-insights' = '? c h'
        'opsi database-insights summarize-sql-response-time-distributions' = '? c h'
        'opsi database-insights summarize-sql-statistics' = '? c h'
        'opsi database-insights summarize-sql-statistics-time-series' = '? c h'
        'opsi database-insights summarize-sql-statistics-time-series-by-plan' = '? c h'
        'opsi database-insights update-autonomous-db' = '? h'
        'opsi database-insights update-em-external-db' = '? h'
        'opsi database-insights update-macs-external-db' = '? h'
        'opsi enterprise-manager-bridges change' = '? c h'
        'opsi enterprise-manager-bridges create' = '? c h'
        'opsi enterprise-manager-bridges delete' = '? h'
        'opsi enterprise-manager-bridges get' = '? h'
        'opsi enterprise-manager-bridges list' = '? c h'
        'opsi enterprise-manager-bridges list-importable-enterprise-manager-entities' = '? h'
        'opsi enterprise-manager-bridges update' = '? h'
        'opsi exadata-insights add-em-external-exadata-members' = '? h'
        'opsi exadata-insights change' = '? c h'
        'opsi exadata-insights create-em-external-exadata' = '? c h'
        'opsi exadata-insights delete' = '? h'
        'opsi exadata-insights disable' = '? h'
        'opsi exadata-insights enable-em-external-exadata' = '? h'
        'opsi exadata-insights get' = '? h'
        'opsi exadata-insights list' = '? c h'
        'opsi exadata-insights list-exadata-configurations' = '? c h'
        'opsi exadata-insights summarize-exadata-insight-resource-capacity-trend' = '? c h'
        'opsi exadata-insights summarize-exadata-insight-resource-capacity-trend-aggregated' = '? c h'
        'opsi exadata-insights summarize-exadata-insight-resource-forecast-trend' = '? h'
        'opsi exadata-insights summarize-exadata-insight-resource-forecast-trend-aggregated' = '? c h'
        'opsi exadata-insights summarize-exadata-insight-resource-statistics' = '? h'
        'opsi exadata-insights summarize-exadata-insight-resource-usage' = '? c h'
        'opsi exadata-insights summarize-exadata-insight-resource-usage-aggregated' = '? c h'
        'opsi exadata-insights summarize-exadata-insight-resource-utilization-insight' = '? c h'
        'opsi exadata-insights summarize-exadata-members' = '? h'
        'opsi exadata-insights update-em-external-exadata' = '? h'
        'opsi host-insights change' = '? c h'
        'opsi host-insights create-em-external-host' = '? c h'
        'opsi host-insights create-macs-external-host' = '? c h'
        'opsi host-insights delete' = '? h'
        'opsi host-insights disable' = '? h'
        'opsi host-insights enable-em-external-host' = '? h'
        'opsi host-insights enable-macs-external-host' = '? h'
        'opsi host-insights get' = '? h'
        'opsi host-insights ingest-host-configuration' = '? h'
        'opsi host-insights ingest-host-metrics' = '? h'
        'opsi host-insights list' = '? c h'
        'opsi host-insights list-host-configurations' = '? c h'
        'opsi host-insights list-hosted-entities' = '? c h'
        'opsi host-insights list-importable-agent-entities' = '? c h'
        'opsi host-insights summarize-host-insight-resource-capacity-trend' = '? c h'
        'opsi host-insights summarize-host-insight-resource-forecast-trend' = '? c h'
        'opsi host-insights summarize-host-insight-resource-statistics' = '? c h'
        'opsi host-insights summarize-host-insight-resource-usage' = '? c h'
        'opsi host-insights summarize-host-insight-resource-usage-trend' = '? c h'
        'opsi host-insights summarize-host-insight-resource-utilization-insight' = '? c h'
        'opsi host-insights update-em-external-host' = '? h'
        'opsi host-insights update-macs-external-host' = '? h'
        'opsi operations-insights-warehouse-users create' = '? c h'
        'opsi operations-insights-warehouse-users delete' = '? h'
        'opsi operations-insights-warehouse-users get' = '? h'
        'opsi operations-insights-warehouse-users list' = '? c h'
        'opsi operations-insights-warehouse-users update' = '? h'
        'opsi operations-insights-warehouses create' = '? c h'
        'opsi operations-insights-warehouses delete' = '? h'
        'opsi operations-insights-warehouses download-warehouse-wallet' = '? h'
        'opsi operations-insights-warehouses get' = '? h'
        'opsi operations-insights-warehouses list' = '? c h'
        'opsi operations-insights-warehouses rotate-warehouse-wallet' = '? h'
        'opsi operations-insights-warehouses summarize-operations-insights-warehouse-resource-usage' = '? h'
        'opsi operations-insights-warehouses update' = '? h'
        'opsi work-requests get' = '? h'
        'opsi work-requests list' = '? c h'
    }
    return $ociCommandsToShortParams
}